---
title: ImageData
slug: Web/API/ImageData
tags:
  - API
  - Canvas
  - ImageData
  - Images
---
<div>{{APIRef("Canvas API")}}</div>

<p><span class="seoSummary">The <code><strong>ImageData</strong></code> interface represents the underlying pixel data of an area of a {{HTMLElement("canvas")}} element.</span> It is created using the {{domxref("ImageData.ImageData", "ImageData()")}} constructor or creator methods on the {{domxref("CanvasRenderingContext2D")}} object associated with a canvas: {{domxref("CanvasRenderingContext2D.createImageData", "createImageData()")}} and {{domxref("CanvasRenderingContext2D.getImageData", "getImageData()")}}. It can also be used to set a part of the canvas by using {{domxref("CanvasRenderingContext2D.putImageData", "putImageData()")}}.</p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Constructors">Constructors</h2>

<dl>
 <dt>{{domxref("ImageData.ImageData", "ImageData()")}} {{experimental_inline}}</dt>
 <dd>Creates an <code>ImageData</code> object from a given {{jsxref("Uint8ClampedArray")}} and the size of the image it contains. If no array is given, it creates an image of a transparent black rectangle. Note that this is the most common way to create such an object in workers as {{domxref("CanvasRenderingContext2D.createImageData", "createImageData()")}} is not available there.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("ImageData.data")}} {{readonlyInline}}</dt>
 <dd>Is a {{jsxref("Uint8ClampedArray")}} representing a one-dimensional array containing the data in the RGBA order, with integer values between <code>0</code> and <code>255</code> (inclusive).</dd>
 <dt>{{domxref("ImageData.height")}} {{readonlyInline}}</dt>
 <dd>Is an <code>unsigned long</code> representing the actual height, in pixels, of the <code>ImageData</code>.</dd>
 <dt>{{domxref("ImageData.width")}} {{readonlyInline}}</dt>
 <dd>Is an <code>unsigned long</code> representing the actual width, in pixels, of the <code>ImageData</code>.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', "canvas.html#imagedata", "ImageData")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.ImageData")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("CanvasRenderingContext2D")}}</li>
 <li>The {{HTMLElement("canvas")}} element and its associated interface, {{domxref("HTMLCanvasElement")}}.</li>
</ul>
